#ifndef MEDIALIBRARY_H
#define MEDIALIBRARY_H

#include <QObject>
#include <QDir>

#include "defines.h"

class MediaLibrary : public QObject
{
    Q_OBJECT
public:

    static MediaLibrary *getInstance();

    inline void setPath(QString path) { m_pathmedia = path; rescanMediaLibrary();}

    QString requestNewFile(int folder, int layer);

private:

    explicit MediaLibrary(QObject *parent = 0);
    static MediaLibrary *_instance;
    inline QString getPath () { return m_pathmedia; } //  Get the path to the medias folder tree.

    inline void deleteMediaLibrary() { delete m_media; m_media = NULL; }
    /**
     * Change library/path
     */
    inline void rescanMediaLibrary()
    {
        deleteMediaLibrary();
        initMediaLibrary();
    }

    QList<MediaFolder> *m_media; // Library to save the folders/media libraries and index each media file inside
    QString m_pathmedia; // Path to Medias

    void initMediaLibrary();
    /** Called when there is a change in the channels folder or file
     * this is called. Creates a new source.
    */


    QList<MediaFile> getMediaInformation(QDir dir); // Get all the information of each media file in a dir

signals:
    
public slots:
    
};

#endif // MEDIALIBRARY_H
